
{$APPTYPE GUI}{$MODE DELPHI}

program demo73;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL;

//const
 
//type
  
var 
  Light:TGLLightProjection;
  Texture:gluint;
  ang:glfloat;
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tu,-1*tv, 0,-1*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Scena(texture:boolean); 
begin 
  // terreno
  if texture then TextureSelectID(0);   
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10, 3,3);
  
  // altri elementi
  if texture then TextureSelectID(1);    
  Cubo2(0,0,0, -3,0,-3, 3,0.5,3, 0.5);
  Cubo2(0,0.5,0, -2.5,0,-2.5, 2.5,0.5,2.5, 0.5); 
  Cubo2(0,0.5*2,0, -2,0,-2, 2,0.5,2, 0.5); 
  Cubo2(0,0.5*3,0, -1.5,0,-1.5, 1.5,0.5,1.5, 0.5); 
  Cubo2(0,0.5*4,0, -1,0,-1, 1,0.5,1, 0.5);
  Cubo2(0,0.5*5,0, -0.5,0,-0.5, 0.5,0.5,0.5, 0.5);   
     
  Cubo2(-6,0,-2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);	 
  Cubo2(-6,0,0, -0.25,0,-0.25, 0.25,3,0.25, 0.5);
  Cubo2(-6,0,2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);  
 
  Cubo2(0,0,-5, -6.5,0,-0.25, 3,1.6,0.25, 0.5);
  
  // torre
  if texture then TextureSelectID(2);   
  Cubo2(6,0,0, -0.7,0,-0.7, 0.7,4.5,0.7, 0.5);   
  Cubo2(6,4.5,0, -1,0,-1, 1,0.5,1, 0.5);
  Cubo2(6-0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6-0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);
  Cubo2(6+0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6+0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);   
  Cubo2(6-0.9+0.6,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5); 
 
  // scultura
  if texture then TextureSelectID(3);  
  glPushMatrix;
  glTranslatef(0,0,7.5);   
  glRotatef(90,-1,0,0); 
  PutglTeapot(0,0,0, 1,32);
  glPopMatrix;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor04.bmp',0);
  TextureLoadID('rock.bmp',1);
  TextureLoadID('stoneblocks.bmp',2);  
  TextureLoadID('marmorizato.bmp',3);  
  TextureLoadTGAID('acero01.tga',Texture);
  
end;
begin 

  OpenGL_Texture();
  
  SetTextureProjection(Light,1.4);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('A')then ang:=ang-2.5;
  if SetglKey('D')then ang:=ang+2.5;
  
end;
begin
  
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(45,1,0,0); 
  
  glRotatef(ang,0,1,0); // rotazione scena 
  //SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 
    
  MSpeed:=2; // setta la velocit dello spostamento della texture	
	
  TextureProjectionBegin(Light,0,0,0);	

  Scena(true); // scena normale con texture  
	
  glBindTexture(GL_TEXTURE_2D,Texture);
  TextureProjectionEnd(Light,0,-20,-15+Depth, 55+xRot,yRot);

  glEnable(GL_BLEND);	
	
  Scena(false); // con texture proiettata

  glDisable(GL_BLEND);	  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di texture proiettata - A\D rotazione scena - mouse spostamento texture', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
